PrefabFiles = {
	"wenyu",
	"woodensword",
	"woodensword_activated",
	"bagualight",
	"kansnow",
	"zhenelec",
	"zhenelecball",
	"duipoison",
	"duipoisoncloud",
	"xunwind",
	"liflame",
}

Assets = {
    Asset( "IMAGE", "images/saveslot_portraits/wenyu.tex" ),
    Asset( "ATLAS", "images/saveslot_portraits/wenyu.xml" ),
	
    Asset( "IMAGE", "images/avatars/avatar_wenyu.tex" ),
    Asset( "ATLAS", "images/avatars/avatar_wenyu.xml" ),
    Asset( "IMAGE", "images/avatars/avatar_ghost_wenyu.tex" ),
    Asset( "ATLAS", "images/avatars/avatar_ghost_wenyu.xml" ),

    Asset( "IMAGE", "bigportraits/wenyu.tex" ),
    Asset( "ATLAS", "bigportraits/wenyu.xml" ),
    Asset( "IMAGE", "bigportraits/wenyu_none.tex" ),
    Asset( "ATLAS", "bigportraits/wenyu_none.xml" ),
	
	Asset( "IMAGE", "images/map_icons/wenyu.tex" ),
	Asset( "ATLAS", "images/map_icons/wenyu.xml" ),
	
    Asset( "IMAGE", "images/names_wenyu.tex" ),
    Asset( "ATLAS", "images/names_wenyu.xml" ),
	
	Asset("IMAGE", "images/hud/taiji.tex"),
	Asset("ATLAS", "images/hud/taiji.xml"),
    Asset("ATLAS", "images/inventoryimages/woodensword.xml"),
    Asset("IMAGE", "images/inventoryimages/woodensword.tex"),
    Asset("ATLAS", "images/inventoryimages/woodensword_activated_qian.xml"),
    Asset("IMAGE", "images/inventoryimages/woodensword_activated_qian.tex"),
    Asset("ATLAS", "images/inventoryimages/woodensword_activated_kun.xml"),
    Asset("IMAGE", "images/inventoryimages/woodensword_activated_kun.tex"),
    Asset("ATLAS", "images/inventoryimages/woodensword_activated_gen.xml"),
    Asset("IMAGE", "images/inventoryimages/woodensword_activated_gen.tex"),
    Asset("ATLAS", "images/inventoryimages/woodensword_activated_dui.xml"),
    Asset("IMAGE", "images/inventoryimages/woodensword_activated_dui.tex"),
    Asset("ATLAS", "images/inventoryimages/woodensword_activated_xun.xml"),
    Asset("IMAGE", "images/inventoryimages/woodensword_activated_xun.tex"),
    Asset("ATLAS", "images/inventoryimages/woodensword_activated_zhen.xml"),
    Asset("IMAGE", "images/inventoryimages/woodensword_activated_zhen.tex"),
    Asset("ATLAS", "images/inventoryimages/woodensword_activated_li.xml"),
    Asset("IMAGE", "images/inventoryimages/woodensword_activated_li.tex"),
    Asset("ATLAS", "images/inventoryimages/woodensword_activated_kan.xml"),
    Asset("IMAGE", "images/inventoryimages/woodensword_activated_kan.tex"),

}

local function initRecipes(tab)
	local TECH = GLOBAL.TECH
	local wsa = AddRecipe("woodensword_activated", 
		{
			Ingredient("woodensword", 1, "images/inventoryimages/woodensword.xml"),
			Ingredient("papyrus", 1),
			Ingredient("nitre", 2)
		},
		tab,
		TECH.NONE, nil, nil, nil, nil, "taoist"
		)
	wsa.atlas = "images/inventoryimages/woodensword_activated.xml"
	wsa.image = "woodensword_activated.tex"
	wsa.sortkey = 50
	
	local recipe = nil
	
	recipe = AddRecipe("woodensword_normal", 
		{
			Ingredient("log", 3),
			Ingredient("rope", 1),
			Ingredient("twigs", 1),
		},
		tab,
		TECH.SCIENCE_ONE, nil, nil, nil, nil, "taoist"
		)
	recipe.atlas = "images/inventoryimages/woodensword.xml"
	recipe.image = "woodensword.tex"
	recipe.sortkey = 75

	recipe = AddRecipe("woodensword_activated_kun", 
		{
			Ingredient("woodensword_activated", 1, "images/inventoryimages/woodensword_activated.xml"),
			Ingredient("nightmarefuel", 1),
		},
		tab,
		TECH.MAGIC_THREE, nil, nil, nil, nil, "taoist"
		)
	recipe.product = "woodensword_activated"
	recipe.atlas = "images/inventoryimages/woodensword_activated_kun.xml"
	recipe.sortkey = 101
	
	recipe = AddRecipe("woodensword_activated_xun", 
		{
			Ingredient("woodensword_activated", 1, "images/inventoryimages/woodensword_activated.xml"),
			Ingredient("butterfly", 3),
		},
		tab,
		TECH.MAGIC_THREE, nil, nil, nil, nil, "taoist"
		)
	recipe.product = "woodensword_activated"
	recipe.atlas = "images/inventoryimages/woodensword_activated_xun.xml"
	recipe.sortkey = 103
	
	recipe = AddRecipe("woodensword_activated_li", 
		{
			Ingredient("woodensword_activated", 1, "images/inventoryimages/woodensword_activated.xml"),
			Ingredient("redgem", 1),
		},
		tab,
		TECH.NONE, nil, nil, nil, nil, "taoist"
		)
	recipe.product = "woodensword_activated"
	recipe.atlas = "images/inventoryimages/woodensword_activated_li.xml"
	recipe.sortkey = 104
	
	recipe = AddRecipe("woodensword_activated_kan", 
		{
			Ingredient("woodensword_activated", 1, "images/inventoryimages/woodensword_activated.xml"),
			Ingredient("bluegem", 1),
		},
		tab,
		TECH.NONE, nil, nil, nil, nil, "taoist"
		)
	recipe.product = "woodensword_activated"
	recipe.atlas = "images/inventoryimages/woodensword_activated_kan.xml"
	recipe.sortkey = 105
	
	recipe = AddRecipe("woodensword_activated_gen", 
		{
			Ingredient("woodensword_activated", 1, "images/inventoryimages/woodensword_activated.xml"),
			Ingredient("purplegem", 1),
		},
		tab,
		TECH.MAGIC_THREE, nil, nil, nil, nil, "taoist"
		)
	recipe.product = "woodensword_activated"
	recipe.atlas = "images/inventoryimages/woodensword_activated_gen.xml"
	recipe.sortkey = 106
	
	recipe = AddRecipe("woodensword_activated_qian", 
		{
			Ingredient("woodensword_activated", 1, "images/inventoryimages/woodensword_activated.xml"),
			Ingredient("thulecite", 1),
		},
		tab,
		TECH.MAGIC_THREE, nil, nil, nil, nil, "taoist"
		)
	recipe.product = "woodensword_activated"
	recipe.atlas = "images/inventoryimages/woodensword_activated_qian.xml"
	recipe.sortkey = 100

	recipe = AddRecipe("woodensword_activated_zhen", 
		{
			Ingredient("woodensword_activated", 1, "images/inventoryimages/woodensword_activated.xml"),
			Ingredient("wormlight_lesser", 5),
		},
		tab,
		TECH.MAGIC_TWO, nil, nil, nil, nil, "taoist"
		)
	recipe.product = "woodensword_activated"
	recipe.atlas = "images/inventoryimages/woodensword_activated_zhen.xml"
	recipe.sortkey = 102
	
	recipe = AddRecipe("woodensword_activated_dui", 
		{
			Ingredient("woodensword_activated", 1, "images/inventoryimages/woodensword_activated.xml"),
			Ingredient("tentaclespots", 2),
		},
		tab,
		TECH.MAGIC_TWO, nil, nil, nil, nil, "taoist"
		)
	recipe.product = "woodensword_activated"
	recipe.atlas = "images/inventoryimages/woodensword_activated_dui.xml"
	recipe.sortkey = 107
end

local require = GLOBAL.require

AddRecipeTab("TAOISM", 999, "images/hud/taiji.xml", "taiji.tex", "taoist")
initRecipes(GLOBAL.CUSTOM_RECIPETABS["TAOISM"])

AddMinimapAtlas("images/map_icons/wenyu.xml")
AddModCharacter("wenyu", "MALE")

local actionabsorb = (function()
	local function findabsorber(act, default, cb)
		local doer = act.doer
		local target = act.target
		if doer.components.inventory then
			local item = doer.components.inventory:GetEquippedItem(GLOBAL.EQUIPSLOTS.HANDS)
			if item and item.components.absorber and item.components.absorber:CanAbsorb(target) then
				return cb(item.components.absorber, default)
			end
		end
		return default
	end
	local v = AddAction("ABSORB", "Absorb", function(act)
		return findabsorber(act, false, function(absorber, default)
			absorber:DoAbsorb(act.doer, act.target)
			return true
		end)
	end)
	v.distance = 2
	v.priority = 3
	v.strfn = function(act)
		local doer = act.doer
		local target = act.target
		if doer.replica.inventory then
			local item = doer.replica.inventory:GetEquippedItem(GLOBAL.EQUIPSLOTS.HANDS)
			if item:HasTag("bagua_li") then
				return "FIRE"
			elseif item:HasTag("bagua_kan") then
				return "EXTINGUISH"
			end
		end
		return "ABSORB"
	end
	AddComponentAction("EQUIPPED", "absorber", function(item, doer, target, actions, right)
		if right and (item:HasTag("bagua_li") or item:HasTag("bagua_kan")) and
			target:HasTag("fire") then
			table.insert(actions, v)
		end
	end)
	return v
end)()
local ah1 = GLOBAL.ActionHandler(actionabsorb, "absorb")
AddStategraphActionHandler("wilson", ah1)
AddStategraphState("wilson", GLOBAL.State({
	name = "absorb",
	tags = {"doing", "busy", "canrotate"},
	onenter = function(inst)
		inst.AnimState:PlayAnimation("atk")
		inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_weapon")
	end,
	timeline = 
	{
		GLOBAL.TimeEvent(8*GLOBAL.FRAMES, function(inst) inst:PerformBufferedAction() end),
	},
	events = {
		GLOBAL.EventHandler("animover", function(inst)
			inst.sg:GoToState("idle") 
		end),
	},
}))
AddStategraphActionHandler("wilson_client", ah1)
AddStategraphState("wilson_client", GLOBAL.State({
	name = "absorb",
	tags = {"doing", "busy", "canrotate"},
	onenter = function(inst)
		inst.AnimState:PlayAnimation("atk")
        inst:PerformPreviewBufferedAction()
	end,
	events = {
		GLOBAL.EventHandler("animover", function(inst)
			inst.sg:GoToState("idle") 
		end),
	},
}))

local actionreactivate = (function()
	local v = AddAction("REACTIVATE", "Reactivate", function(act)
		local doer = act.invobject
		if doer and doer.components.bagua then
			doer.components.bagua:Reactivate(act.doer)
			return true
		end
		return false
	end)
	v.priority = -1
	AddComponentAction("INVENTORY", "bagua", function(item, doer, actions, right)
		if (right or GLOBAL.modwenyu.pressctrl[doer.GUID]) and item:HasTag("reactivatable") then
			table.insert(actions, v)
		end
	end)
	return v
end)()
local ah2 = GLOBAL.ActionHandler(actionreactivate, "dolongaction")
AddStategraphActionHandler("wilson", ah2)
AddStategraphActionHandler("wilson_client", ah2)
AddModRPCHandler(modname, "PressCtrl", function(playerinst)
	GLOBAL.modwenyu.pressctrl[playerinst.GUID] = true
end)
AddModRPCHandler(modname, "ReleaseCtrl", function(playerinst)
	GLOBAL.modwenyu.pressctrl[playerinst.GUID] = false
end)
AddSimPostInit(function()
	if not GLOBAL.TheNet:IsDedicated() then
		GLOBAL.TheInput:AddKeyHandler(function(key, down)
			if GLOBAL.ThePlayer == nil then
				return
			end
			if key == GLOBAL.KEY_CTRL or key == GLOBAL.KEY_LCTRL or key == GLOBAL.KEY_RCTRL then
				if down then
					if not GLOBAL.modwenyu.pressctrl[GLOBAL.ThePlayer.GUID] then
						SendModRPCToServer(GetModRPC(modname, "PressCtrl"))
						GLOBAL.modwenyu.pressctrl[GLOBAL.ThePlayer.GUID] = true
					end
				else
					SendModRPCToServer(GetModRPC(modname, "ReleaseCtrl"))
					GLOBAL.modwenyu.pressctrl[GLOBAL.ThePlayer.GUID] = false
				end
			end
		end)
	end
end)

local actionbagua = (function()
	local v = AddAction("BAGUA", "Copy Effect", function(act)
		local doer = act.invobject
		local target = act.target
		if doer and doer.components.bagua and target then
			doer.components.bagua:Copy(act.doer, target)
			return true
		end
		return false
	end)
	AddComponentAction("USEITEM", "bagua", function(inst, doer, target, actions, right)
		if right and doer.prefab == "wenyu" and inst.prefab == "woodensword_activated" and target.prefab == "woodensword_normal" then
			table.insert(actions, v)
		end
	end)
	return v
end)()
local ah3 = GLOBAL.ActionHandler(actionbagua, "dolongaction")
AddStategraphActionHandler("wilson", ah3)
AddStategraphActionHandler("wilson_client", ah3)

GLOBAL.modwenyu = {
	LANGUAGE = GetModConfigData("LANGUAGE"),
	pressctrl = {},
}

local function deepmerge(t1, t2)
	for k,v in pairs(t2) do
		if not t1[k] then
			t1[k] = v
		elseif type(t1[k]) == "table" and type(v) == "table" then
			deepmerge(t1[k], v)
		else
			t1[k] = v
		end
	end
end

local mod_constants = require "modwenyu_constants"
deepmerge(GLOBAL, mod_constants)

-- taoist diet
local taoistforbiddenfoods = (function(data)
	local result = {}
	for k,v in pairs(data) do
		result[v] = true
	end
	return result
end)({
	-- old and giant fish
	"fish", "eel", "fish_cooked", "eel_cooked",
	-- sw fish
	"tropical_fish",
	"fish_raw", "fish_med", "fish_med_cooked", "swordfish", "shark_fin",
	"fish_raw_small",
	-- old and giant cooked fish
	"fishsticks", "fishtacos", "unagi",
	-- sw cooked fish
	"californiaroll", "seafoodgumbo", "ceviche", "surfnturf",
})
AddPrefabPostInitAny(function(inst)
	if inst.components.edible and not taoistforbiddenfoods[inst.prefab] then
		local isomni = false
		for k,v in pairs(GLOBAL.FOODGROUP.OMNI.types) do
			if inst.components.edible.foodtype == v then
				isomni = true
				break
			end
		end
		if isomni then
			inst:AddTag("edible_"..GLOBAL.FOODTYPE.TAOIST)
		end
	end
end)

