local DuiPoison = Class(function(self, inst)
	self.inst = inst
	self.target = nil
	self.dpt = 0
	
	self.inst:StartUpdatingComponent(self)
end)

function DuiPoison:OnSave()
    return 
	{
		dpt = self.dpt,
		target = self.target and self.target.GUID,
	},
	{
		self.target and self.target.GUID
	}
end

function DuiPoison:OnLoad(data)
	if data then
		self.dpt = data.dpt or self.dpt
	end
end

function DuiPoison:LoadPostPass(newents, data)
	if data then
		self.target = data.target and newents[data.target] and newents[data.target].entity
	end
end

function DuiPoison:OnUpdate(dt)
	if self.target and self.target.components.health then
		local pos = self.target:GetPosition()
		pos.y = pos.y + self.target.Physics:GetHeight()
		self.inst.Transform:SetPosition(pos:Get())
		
		local health = self.target.components.health
		if health:IsDead() then
			self.target = nil
			if self.ontargetdead then self.ontargetdead(self.inst) end
		else
			self.dpt = self.dpt + dt
			if self.dpt > TUNING.DUIPOISON_DAMAGE_PERIOD then
				health:DoDelta(-TUNING.DUIPOISON_DAMAGE_PERIOD * TUNING.DUIPOISON_DAMAGE_PER_SEC, 0, self.inst.prefab)
				self.dpt = self.dpt - TUNING.DUIPOISON_DAMAGE_PERIOD
			end
		end
	end
end

return DuiPoison
