local LiFlame = Class(function(self, inst)
	self.inst = inst
	self.target = nil
	self.dpt = 0
	
	self.inst:StartUpdatingComponent(self)
end)

function LiFlame:OnSave()
    return 
	{
		dpt = self.dpt,
		target = self.target and self.target.GUID,
	},
	{
		self.target and self.target.GUID
	}
end

function LiFlame:OnLoad(data)
	if data then
		self.dpt = data.dpt or self.dpt
	end
end

function LiFlame:LoadPostPass(newents, data)
	if data then
		local target = data.target and newents[data.target] and newents[data.target].entity
		if target then
			self:SetTarget(target)
		end
	end
end

function LiFlame:OnUpdate(dt)
	if self.target and self.target.components.health then
		local pos = self.target:GetPosition()
		pos.y = pos.y + self.target.Physics:GetHeight()
		self.inst.Transform:SetPosition(pos:Get())
		
		local health = self.target.components.health
		if health:IsDead() then
			self.target = nil
			self.inst:RemoveEventCallback("onremove", self.removeeacb)
			if self.ontargetdead then self.ontargetdead(self.inst) end
		else
			self.dpt = self.dpt + dt
			if self.dpt > TUNING.LIFLAME_DAMAGE_PERIOD then
				health:DoDelta(-TUNING.LIFLAME_DAMAGE_PERIOD * TUNING.LIFLAME_DAMAGE_PER_SEC, 0, self.inst.prefab)
				self.dpt = self.dpt - TUNING.LIFLAME_DAMAGE_PERIOD
			end
		end
	end
end

function LiFlame:SetTarget(target)
	self.target = target
	
	local callback = function(inst, data)
		if target.components.health then
			target.components.health:DoDelta(-TUNING.LIFLAME_EXTRA_DAMAGE, 0, self.inst.prefab)
		end
	end
	
	target:ListenForEvent("attacked", callback)
	
	local callback2 = function(inst)
		target:RemoveEventCallback("attacked", callback)
	end
	
	self.inst:ListenForEvent("onremove", callback2)
	self.removeeacb = callback2
end

return LiFlame
