local assets =
{
    Asset("ANIM", "anim/xunwind.zip"),
}

local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
	
    inst.entity:AddNetwork()
	
    anim:SetBank("xunwind")
    anim:SetBuild("xunwind")
    anim:PlayAnimation("idle", true)
	
	inst:AddTag("fx")
	
    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end
	
	inst:AddComponent("limitedlife")
	inst.components.limitedlife.life = TUNING.XUNWIND_LIFETIME
	
	inst:DoPeriodicTask(0.5, function()
		local pos = inst:GetPosition()
		local ents = TheSim:FindEntities(pos.x, pos.y, pos.z, 1, {"monster"}, {"character", "dead"})
		for k,v in pairs(ents) do
			if v.components.combat then
				v.components.combat:GetAttacked(inst, TUNING.XUNWIND_DAMAGE, nil)
			end
		end
	end)
	
    return inst
end

return Prefab( "common/fx/xunwind", fn, assets) 